## freeminer-80629f40a85fccafaefea1a490d9ca384f73493f.zip

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 2.6)

if(${CMAKE_VERSION} STREQUAL "2.8.2")
	# Bug http://vtk.org/Bug/view.php?id=11020
	message(WARNING "CMake/CPack version 2.8.2 will not create working .deb packages!")
endif()

# This can be read from ${PROJECT_NAME} after project() is called
project(freeminer)
set(PROJECT_NAME_CAPITALIZED "freeminer")

set(CMAKE_CXX_STANDARD 17)

# Also remember to set PROTOCOL_VERSION in network/networkprotocol.h when releasing
set(VERSION_MAJOR 0)
set(VERSION_MINOR 4)
set(VERSION_PATCH 15)
set(VERSION_EXTRA "" CACHE STRING "Stuff to append to version string")

set(VERSION_TWEAK 8)

# Change to false for releases
set(DEVELOPMENT_BUILD TRUE)

set(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_TWEAK}")
if(VERSION_EXTRA)
	set(VERSION_STRING ${VERSION_STRING}-${VERSION_EXTRA})
elseif(DEVELOPMENT_BUILD)
	set(VERSION_STRING "${VERSION_STRING}-dev")
endif()

message(STATUS "*** Will build version ${VERSION_STRING} ***")

set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

# Configuration options
set(DEFAULT_RUN_IN_PLACE TRUE)
if(WIN32)
	set(DEFAULT_RUN_IN_PLACE TRUE)
endif()
set(RUN_IN_PLACE ${DEFAULT_RUN_IN_PLACE} CACHE BOOL
	"Run directly in source directory structure")


set(BUILD_CLIENT TRUE CACHE BOOL "Build client")
if(WIN32 OR APPLE)
	# win32 broken! http://forum.freeminer.org/threads/building-errors.182/#post-1852
	#if( ${CMAKE_SYSTEM_VERSION} VERSION_LESS 6.0 )
	#	MESSAGE(FATAL_ERROR "Building is not supported for Windows ${CMAKE_SYSTEM_VERSION}")
	#endif()
	set(BUILD_SERVER FALSE CACHE BOOL "Build server")
else()
	set(BUILD_SERVER TRUE CACHE BOOL "Build server")
endif()


set(WARN_ALL TRUE CACHE BOOL "Enable -Wall for Release build")

set(DEBUG 0 CACHE BOOL "Build with debug symbols and without optimization")
if(DEBUG)
	set(CMAKE_BUILD_TYPE Debug CACHE STRING "Build type: Debug or Release" FORCE)
else()
	set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type: Debug or Release" FORCE)
endif()
MARK_AS_ADVANCED(CMAKE_BUILD_TYPE)
MESSAGE(STATUS "Build type: ${CMAKE_BUILD_TYPE}")


# Included stuff
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")


# This is done here so that relative search paths are more reasonable
if(NOT NO_BUILD)
find_package(Irrlicht)
endif()


# Installation

if(WIN32)
	set(SHAREDIR ".")
	set(BINDIR "bin")
	set(DOCDIR "doc")
	set(EXAMPLE_CONF_DIR ".")
	set(LOCALEDIR "locale")
elseif(APPLE)
	set(BUNDLE_NAME ${PROJECT_NAME}.app)
	set(BUNDLE_PATH "${BUNDLE_NAME}")
	set(BINDIR ${BUNDLE_NAME}/Contents/MacOS)
	set(SHAREDIR ${BUNDLE_NAME}/Contents/Resources)
	set(DOCDIR "${SHAREDIR}/${PROJECT_NAME}")
	set(EXAMPLE_CONF_DIR ${DOCDIR})
	set(LOCALEDIR "${SHAREDIR}/locale")
elseif(UNIX) # Linux, BSD etc
	if(RUN_IN_PLACE)
		set(SHAREDIR ".")
		set(BINDIR "bin")
		set(DOCDIR "doc")
		set(EXAMPLE_CONF_DIR ".")
		set(MANDIR "unix/man")
		set(XDG_APPS_DIR "unix/applications")
		set(APPDATADIR "unix/appdata")
		set(ICONDIR "unix/icons")
		set(LOCALEDIR "locale")
	else()
		set(SHAREDIR "${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}")
		set(BINDIR "${CMAKE_INSTALL_PREFIX}/bin")
		set(DOCDIR "${CMAKE_INSTALL_PREFIX}/share/doc/${PROJECT_NAME}")
		set(MANDIR "${CMAKE_INSTALL_PREFIX}/share/man")
		set(EXAMPLE_CONF_DIR ${DOCDIR})
		set(XDG_APPS_DIR "${CMAKE_INSTALL_PREFIX}/share/applications")
		set(APPDATADIR "${CMAKE_INSTALL_PREFIX}/share/appdata")
		set(ICONDIR "${CMAKE_INSTALL_PREFIX}/share/icons")
		set(LOCALEDIR "${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/locale")
	endif()
endif()

set(CUSTOM_SHAREDIR "" CACHE STRING "Directory to install data files into")
if(NOT CUSTOM_SHAREDIR STREQUAL "")
	set(SHAREDIR "${CUSTOM_SHAREDIR}")
	message(STATUS "Using SHAREDIR=${SHAREDIR}")
endif()

set(CUSTOM_BINDIR "" CACHE STRING "Directory to install binaries into")
if(NOT CUSTOM_BINDIR STREQUAL "")
	set(BINDIR "${CUSTOM_BINDIR}")
	message(STATUS "Using BINDIR=${BINDIR}")
endif()

set(CUSTOM_DOCDIR "" CACHE STRING "Directory to install documentation into")
if(NOT CUSTOM_DOCDIR STREQUAL "")
	set(DOCDIR "${CUSTOM_DOCDIR}")
	if(NOT RUN_IN_PLACE)
		set(EXAMPLE_CONF_DIR ${DOCDIR})
	endif()
	message(STATUS "Using DOCDIR=${DOCDIR}")
endif()

set(CUSTOM_MANDIR "" CACHE STRING "Directory to install manpages into")
if(NOT CUSTOM_MANDIR STREQUAL "")
	set(MANDIR "${CUSTOM_MANDIR}")
	message(STATUS "Using MANDIR=${MANDIR}")
endif()

set(CUSTOM_EXAMPLE_CONF_DIR "" CACHE STRING "Directory to install example config file into")
if(NOT CUSTOM_EXAMPLE_CONF_DIR STREQUAL "")
	set(EXAMPLE_CONF_DIR "${CUSTOM_EXAMPLE_CONF_DIR}")
	message(STATUS "Using EXAMPLE_CONF_DIR=${EXAMPLE_CONF_DIR}")
endif()

set(CUSTOM_XDG_APPS_DIR "" CACHE STRING "Directory to install .desktop files into")
if(NOT CUSTOM_XDG_APPS_DIR STREQUAL "")
	set(XDG_APPS_DIR "${CUSTOM_XDG_APPS_DIR}")
	message(STATUS "Using XDG_APPS_DIR=${XDG_APPS_DIR}")
endif()

set(CUSTOM_ICONDIR "" CACHE STRING "Directory to install icons into")
if(NOT CUSTOM_ICONDIR STREQUAL "")
	set(ICONDIR "${CUSTOM_ICONDIR}")
	message(STATUS "Using ICONDIR=${ICONDIR}")
endif()

set(CUSTOM_LOCALEDIR "" CACHE STRING "Directory to install l10n files into")
if(NOT CUSTOM_LOCALEDIR STREQUAL "")
	set(LOCALEDIR "${CUSTOM_LOCALEDIR}")
	message(STATUS "Using LOCALEDIR=${LOCALEDIR}")
endif()


install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/builtin" DESTINATION "${SHAREDIR}")
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/client" DESTINATION "${SHAREDIR}")
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/games" DESTINATION "${SHAREDIR}" PATTERN ".git*" EXCLUDE)

if(BUILD_CLIENT)
	install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/textures/base/pack" DESTINATION "${SHAREDIR}/textures/base")
endif()
if(RUN_IN_PLACE)
	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/mods/mods_here.txt" DESTINATION "${SHAREDIR}/mods")
	install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/textures/texture_packs_here.txt" DESTINATION "${SHAREDIR}/textures")
endif()

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/fonts" DESTINATION "${SHAREDIR}")

install(FILES "README.md" DESTINATION "${DOCDIR}")
install(FILES "doc/lua_api.txt" DESTINATION "${DOCDIR}")
install(FILES "doc/menu_lua_api.txt" DESTINATION "${DOCDIR}")
install(FILES "doc/texture_packs.txt" DESTINATION "${DOCDIR}")
install(FILES "doc/world_format.txt" DESTINATION "${DOCDIR}")
install(FILES "freeminer.conf.example" DESTINATION "${EXAMPLE_CONF_DIR}")

if(UNIX AND NOT APPLE)
	install(FILES "doc/freeminer.6" "doc/freeminerserver.6" DESTINATION "${MANDIR}/man6")
	install(FILES "misc/freeminer.desktop" DESTINATION "${XDG_APPS_DIR}")
	install(FILES "misc/freeminer.appdata.xml" DESTINATION "${APPDATADIR}")
	install(FILES "misc/freeminer.svg" DESTINATION "${ICONDIR}/hicolor/scalable/apps")
	install(FILES "misc/freeminer-xorg-icon-128.png"
		DESTINATION "${ICONDIR}/hicolor/128x128/apps"
		RENAME "freeminer.png")
endif()

if(APPLE)
	install(FILES "misc/freeminer-icon.icns" DESTINATION "${SHAREDIR}")
	install(FILES "misc/Info.plist" DESTINATION "${BUNDLE_PATH}/Contents")
endif()


# Subdirectories
# Be sure to add all relevant definitions above this

add_subdirectory(src)


# CPack

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "An InfiniMiner/Minecraft inspired game")
set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
set(CPACK_PACKAGE_VERSION_TWEAK ${VERSION_TWEAK})
set(CPACK_PACKAGE_VENDOR "celeron55")
set(CPACK_PACKAGE_CONTACT "Perttu Ahola <celeron55@gmail.com>")

if(WIN32)
	# For some reason these aren't copied otherwise
	# NOTE: For some reason now it seems to work without these
	#if(BUILD_CLIENT)
	#	install(FILES bin/freeminer.exe DESTINATION bin)
	#endif()
	#if(BUILD_SERVER)
	#	install(FILES bin/freeminerserver.exe DESTINATION bin)
	#endif()

	execute_process(COMMAND git describe --always --tag --dirty
		WORKING_DIRECTORY "${GENERATE_VERSION_SOURCE_DIR}"
		OUTPUT_VARIABLE VERSION_GITHASH OUTPUT_STRIP_TRAILING_WHITESPACE
		ERROR_QUIET)

	if(VERSION_GITHASH)
		set(PROJECT_VERSION ${VERSION_GITHASH})
	else()
		set(PROJECT_VERSION ${VERSION_STRING})
	endif()

	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-win64")
	else()
		set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}-win32")
	endif()

	set(CPACK_GENERATOR ZIP)

	# This might be needed for some installer
	#set(CPACK_PACKAGE_EXECUTABLES bin/freeminer.exe "Freeminer" bin/freeminerserver.exe "Freeminer Server")
elseif(APPLE)
	set(CPACK_INCLUDE_TOPLEVEL_DIRECTORY 0)
	set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-osx")
	set(CPACK_GENERATOR ZIP)
else()
	set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-linux")
	set(CPACK_GENERATOR TGZ)
	set(CPACK_SOURCE_GENERATOR TGZ)
endif()

include(CPack)


# Add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in
			${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile @ONLY)
	add_custom_target(doc
		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile
		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc
		COMMENT "Generating API documentation with Doxygen" VERBATIM
	)
endif()

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(freeminer)

INCLUDE(CheckIncludeFiles)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckCXXSourceRuns)

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# test compiler capabilities

if(MSVC)
else()
	option(ENABLE_CXX1Y "Try use C++14 features (shared_mutex) *experimental!*" 0)
	if(ENABLE_CXX1Y)
		#set(STD_FLAGS "-std=c++1y -stdlib=libstdc++ -lc++")
		set(STD_FLAGS "-std=c++1y")
		if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
			set(STD_FLAGS "${STD_FLAGS} -lstdc++")
		endif()
		set(CMAKE_REQUIRED_FLAGS "${STD_FLAGS}")
		CHECK_CXX_SOURCE_RUNS("
			#include <shared_mutex>
			int main(int argc, char *argv[]) {
				std::shared_timed_mutex m;
				std::shared_lock<std::shared_timed_mutex> lock(m);
				lock.unlock();
				return 0;
			}
			"
			HAVE_SHARED_MUTEX)
	else()
		if(WIN32) # http://forum.freeminer.org/threads/building-errors.182/#post-1855
			#set(STD_FLAGS "-std=gnu++0x")
		else()
			#set(STD_FLAGS "-std=c++0x")
		endif()
	endif()
endif()

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

CHECK_CXX_SOURCE_RUNS("
	#include <string>
	thread_local std::string test;
	int main(int argc, char *argv[]) {
		test = __LINE__;
		return 0;
	}
	"
	HAVE_THREAD_LOCAL)
if(NOT HAVE_THREAD_LOCAL)
	set(HAVE_THREAD_LOCAL 0)
endif()

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

CHECK_CXX_SOURCE_RUNS("
	#include <future>
	int main(int argc, char *argv[]) {
		std::future<void> updateDrawList_future;
		bool allow = false;
		if (updateDrawList_future.valid()) {
			auto res = updateDrawList_future.wait_for(std::chrono::milliseconds(0));
			if (res == std::future_status::timeout)
				allow = false;
		}
		if (false)
			updateDrawList_future = std::async(std::launch::async, [](){ });
		return 0;
	}
	"
	HAVE_FUTURE)
if(NOT HAVE_FUTURE)
	set(HAVE_FUTURE 0)
endif()

set(CMAKE_REQUIRED_FLAGS "")

if(MSVC)
	option(ENABLE_THREADS "Use more threads (might be slower on 1-2 core machines)" 1)
else()
	option(ENABLE_THREADS "Use more threads (might be slower on 1-2 core machines)" 1)
endif()

if(ENABLE_THREADS)
	set(ENABLE_THREADS 1)
else()
	set(ENABLE_THREADS 0)
endif()


option(MINETEST_PROTO "Use minetest protocol (Slow and buggy)" 0)
if(MINETEST_PROTO)
	set(MINETEST_PROTO 1)
	set(USE_ENET 0)
	message(STATUS "Using minetest compatible networking (slow, some features missing)")
else()
	set(USE_ENET 1)
	set(MINETEST_PROTO 0)
endif()

#
# Set some optimizations and tweaks
#

include(CheckCXXCompilerFlag)

if(STATIC_BUILD)
	set(STATIC_BUILD 1)
else()
	set(STATIC_BUILD 0)
endif()

if(MSVC)
	# Visual Studio

	# EHa enables SEH exceptions (used for catching segfaults)
	set(CMAKE_CXX_FLAGS_RELEASE "/EHa /Ox /GL /FD /MT /GS- /Zi /arch:SSE /fp:fast /D NDEBUG /D _HAS_ITERATOR_DEBUGGING=0 /TP")
	#set(CMAKE_EXE_LINKER_FLAGS_RELEASE "/LTCG /NODEFAULTLIB:\"libcmtd.lib\" /NODEFAULTLIB:\"libcmt.lib\"")
	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "/LTCG /DEBUG /OPT:REF /OPT:ICF")

	set(CMAKE_CXX_FLAGS_SEMIDEBUG "/MDd /Zi /Ob0 /O1 /RTC1")

	# Debug build doesn't catch exceptions by itself
	# Add some optimizations because otherwise it's VERY slow
	set(CMAKE_CXX_FLAGS_DEBUG "/MDd /Zi /Ob0 /Od /RTC1")

	if (STATIC_BUILD)
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /D _IRR_STATIC_LIB_ /D AL_LIBTYPE_STATIC /D CURL_STATICLIB")
		set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /D _IRR_STATIC_LIB_ /D AL_LIBTYPE_STATIC /D CURL_STATICLIB")
	endif()

	# Flags for C files (sqlite)
	# /MT = Link statically with standard library stuff
	set(CMAKE_C_FLAGS_RELEASE "/O2 /Ob2 /MT")
else()
	# Probably GCC
	if(APPLE)
		SET( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -pagezero_size 10000 -image_base 100000000" )
	endif()
	if(WARN_ALL)
		set(RELEASE_WARNING_FLAGS "-Wall")
	else()
		set(RELEASE_WARNING_FLAGS "")
	endif()

	set(OTHER_FLAGS "")

	if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
		# clang does not understand __extern_always_inline but libc headers use it
		set(OTHER_FLAGS "${OTHER_FLAGS} \"-D__extern_always_inline=extern __always_inline\"")
		set(OTHER_FLAGS "${OTHER_FLAGS} -Wsign-compare")
	endif()

	if("${CMAKE_GENERATOR}" STREQUAL "Ninja" )
        if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
			set(OTHER_FLAGS "${OTHER_FLAGS}  -fdiagnostics-color")
        elseif ( CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.8 )
			set(OTHER_FLAGS "${OTHER_FLAGS}  -fdiagnostics-color=always")
        endif ()
	endif ()

	if(WIN32 AND NOT ZLIBWAPI_DLL AND CMAKE_SIZEOF_VOID_P EQUAL 4)
		set(OTHER_FLAGS "${OTHER_FLAGS} -DWIN32_NO_ZLIB_WINAPI")
		message(WARNING "Defaulting to cdecl for zlib on win32 because ZLIBWAPI_DLL"
			" isn't set, ensure that ZLIBWAPI_DLL is set if you want stdcall.")
	endif()

	if(MINGW)
		set(OTHER_FLAGS "${OTHER_FLAGS} -mthreads -fexceptions")
	endif()


	if(SANITIZE_ADDRESS)
		set(OTHER_FLAGS "${OTHER_FLAGS} -fsanitize=address -fno-omit-frame-pointer -fno-optimize-sibling-calls")
	endif()
	if(SANITIZE_THREAD)
		set(OTHER_FLAGS "${OTHER_FLAGS} -fsanitize=thread -fPIE -fno-omit-frame-pointer -fno-optimize-sibling-calls")
		if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
			set(OTHER_FLAGS "${OTHER_FLAGS} -pie")
		endif()
	endif()
	if(SANITIZE_MEMORY)
		set(OTHER_FLAGS "${OTHER_FLAGS} -fsanitize=memory -fPIE -fno-omit-frame-pointer -fno-optimize-sibling-calls")
		SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
	endif()
	if(SANITIZE_UNDEFINED)
		set(OTHER_FLAGS "${OTHER_FLAGS} -fsanitize=undefined -fno-omit-frame-pointer -fno-optimize-sibling-calls")
	endif()
	if(USE_GPERF)
		SET(PLATFORM_LIBS ${PLATFORM_LIBS} -ltcmalloc -lprofiler)
		SET(OTHER_FLAGS "${OTHER_FLAGS} -fno-builtin-malloc -fno-builtin-calloc -fno-builtin-realloc -fno-builtin-free")
	endif()


	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${OTHER_FLAGS}")
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${OTHER_FLAGS}")

	set(CMAKE_CXX_FLAGS_RELEASE "${STD_FLAGS} -DNDEBUG ${RELEASE_WARNING_FLAGS} ${WARNING_FLAGS} ${OTHER_FLAGS} -ffast-math -Wall -pipe -funroll-loops")

	if(APPLE)
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -Os")
	else()
		set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -fomit-frame-pointer")
	endif()

	set(CMAKE_CXX_FLAGS_SEMIDEBUG "${STD_FLAGS} -g -O1 -Wall -Wabi ${WARNING_FLAGS} ${OTHER_FLAGS}")
	set(CMAKE_CXX_FLAGS_DEBUG "${STD_FLAGS} -g -O0 -Wall -Wabi ${WARNING_FLAGS} ${OTHER_FLAGS}")

	if(USE_GPROF)
		set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -pg")
	endif()

endif()

if(NOT HAVE_SHARED_MUTEX)
	# avoid empty value in cmake_config.h
	set(HAVE_SHARED_MUTEX 0)
endif()

# Add custom SemiDebug build mode
set(CMAKE_CXX_FLAGS_SEMIDEBUG "-O1 -g -Wall -Wabi" CACHE STRING
	"Flags used by the C++ compiler during semidebug builds."
	FORCE
)
set(CMAKE_C_FLAGS_SEMIDEBUG "-O1 -g -Wall -pedantic" CACHE STRING
	"Flags used by the C compiler during semidebug builds."
	FORCE
)
mark_as_advanced(
	CMAKE_CXX_FLAGS_SEMIDEBUG
	CMAKE_C_FLAGS_SEMIDEBUG
)
set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
	"Choose the type of build. Options are: None Debug SemiDebug RelWithDebInfo MinSizeRel."
	FORCE
)


# Set some random things default to not being visible in the GUI
mark_as_advanced(EXECUTABLE_OUTPUT_PATH LIBRARY_OUTPUT_PATH)

find_package(MsgPack REQUIRED)

if(NOT (BUILD_CLIENT OR BUILD_SERVER OR NO_BUILD))
	message(WARNING "Neither BUILD_CLIENT nor BUILD_SERVER is set! Setting BUILD_SERVER=true")
	set(BUILD_SERVER TRUE)
endif()


option(ENABLE_CURL "Enable cURL support for fetching media" TRUE)
set(USE_CURL FALSE)

if(ENABLE_CURL)
	find_package(CURL)
	if (CURL_FOUND)
		message(STATUS "cURL support enabled.")
		set(USE_CURL TRUE)
	endif()
else()
	mark_as_advanced(CLEAR CURL_LIBRARY CURL_INCLUDE_DIR)
endif()

option(ENABLE_ICONV "Enable utf8 convert via iconv " FALSE)

if(ENABLE_ICONV)
	find_package(Iconv)
	if(ICONV_INCLUDE_DIR)
		set(USE_ICONV 1)
		message(STATUS "iconv.h found: ${ICONV_INCLUDE_DIR}")
	else()
		message(STATUS "iconv.h NOT found")
	endif()
endif()

if(NOT USE_ICONV)
	set(USE_ICONV 0)
endif()

if(NOT USE_CURL)
	if(BUILD_CLIENT)
		message(WARNING "cURL is required to load the server list")
	endif()
	if(BUILD_SERVER)
		message(WARNING "cURL is required to announce to the server list")
	endif()
endif()


if(BUILD_CLIENT)
OPTION(ENABLE_GETTEXT "Use GetText for internationalization" TRUE)
else()
option(ENABLE_GETTEXT "Use GetText for internationalization" FALSE)
endif()
set(USE_GETTEXT FALSE)

if(ENABLE_GETTEXT)
	find_package(GettextLib)
	if(GETTEXT_FOUND)
		if(WIN32)
			message(STATUS "GetText library: ${GETTEXT_LIBRARY}")
			message(STATUS "GetText DLL: ${GETTEXT_DLL}")
			message(STATUS "GetText iconv DLL: ${GETTEXT_ICONV_DLL}")
		endif()
		set(USE_GETTEXT TRUE)
		message(STATUS "GetText enabled; locales found: ${GETTEXT_AVAILABLE_LOCALES}")
	endif(GETTEXT_FOUND)
else()
	mark_as_advanced(GETTEXT_ICONV_DLL GETTEXT_INCLUDE_DIR GETTEXT_LIBRARY GETTEXT_MSGFMT ICONV_LIBRARY)
	message(STATUS "GetText disabled.")
endif()

if(BUILD_CLIENT)
option(ENABLE_SOUND "Enable sound" TRUE)
else()
option(ENABLE_SOUND "Enable sound" FALSE)
endif()
set(USE_SOUND FALSE)

if(ENABLE_SOUND AND BUILD_CLIENT)
	# Sound libraries
	find_package(OpenAL)
	find_package(Vorbis)
	if(NOT OPENAL_FOUND)
		message(STATUS "Sound enabled, but OpenAL not found!")
		mark_as_advanced(CLEAR OPENAL_LIBRARY OPENAL_INCLUDE_DIR)
	endif()
	if(NOT VORBIS_FOUND)
		message(STATUS "Sound enabled, but Vorbis libraries not found!")
		mark_as_advanced(CLEAR OGG_INCLUDE_DIR VORBIS_INCLUDE_DIR OGG_LIBRARY VORBIS_LIBRARY VORBISFILE_LIBRARY)
	endif()
	if(OPENAL_FOUND AND VORBIS_FOUND)
		set(USE_SOUND TRUE)
		message(STATUS "Sound enabled.")
	else()
		message(WARNING "Sound enabled, but cannot be used.\n")
	endif()
endif()

if(USE_SOUND)
	set(sound_SRCS sound_openal.cpp)
	set(SOUND_INCLUDE_DIRS
		${OPENAL_INCLUDE_DIR}
		${VORBIS_INCLUDE_DIR}
		${OGG_INCLUDE_DIR}
		)
	set(SOUND_LIBRARIES
		${OPENAL_LIBRARY}
		${VORBIS_LIBRARIES}
		)
endif()


if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
option(ENABLE_GLES "Enable OpenGL ES support (ARM, android. special irrlicht version needed!)" TRUE)
else()
option(ENABLE_GLES "Enable OpenGL ES support (ARM, android. special irrlicht version needed!)" FALSE)
mark_as_advanced(ENABLE_GLES)
endif()

if(BUILD_CLIENT AND ENABLE_GLES)
	find_package(OpenGLES2)
endif()


#option(ENABLE_FREETYPE "Enable FreeType2 (TrueType fonts and basic unicode support)" TRUE)
#mark_as_advanced(ENABLE_FREETYPE)
set(USE_FREETYPE FALSE)

##
## Note: FindFreetype.cmake seems to have been fixed in recent versions of
## CMake. If issues persist, re-enable this workaround specificially for the
## failing platforms.
##
#	if(${CMAKE_SYSTEM} MATCHES "FreeBSD")
#		#PkgConfig not worked. result: /usr/bin/ld: cannot find -lfreetype
#	elseif(UNIX)
#		include(FindPkgConfig)
#		if(PKG_CONFIG_FOUND)
#			pkg_check_modules(FREETYPE QUIET freetype2)
#			if(FREETYPE_FOUND)
#				SET(FREETYPE_PKGCONFIG_FOUND TRUE)
#				SET(FREETYPE_LIBRARY ${FREETYPE_LIBRARIES})
#				# Because CMake is idiotic
#				string(REPLACE ";" " " FREETYPE_CFLAGS_STR ${FREETYPE_CFLAGS})
#				string(REPLACE ";" " " FREETYPE_LDFLAGS_STR ${FREETYPE_LDFLAGS})
#			endif(FREETYPE_FOUND)
#		endif(PKG_CONFIG_FOUND)
#	endif()
#	if(NOT FREETYPE_FOUND)
#		find_package(Freetype)
#	endif()
	find_package(Freetype)

	if(FREETYPE_FOUND)
		message(STATUS "Freetype enabled.")
		set(USE_FREETYPE TRUE)
		set(CGUITTFONT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cguittfont")
		set(CGUITTFONT_LIBRARY cguittfont)
	endif()

if(NOT FREETYPE_FOUND AND NOT NO_BUILD AND BUILD_CLIENT)
	message(FATAL_ERROR "FreeType was not found.")
endif()

# LuaJIT
option(ENABLE_LUAJIT "Enable LuaJIT support" TRUE)
set(USE_LUAJIT FALSE)
if(ENABLE_LUAJIT)
	find_package(LuaJIT)
	if(LUAJIT_FOUND)
		set(USE_LUAJIT TRUE)
	endif(LUAJIT_FOUND)
else()

=== build/android/Makefile ===
# build options

OS := $(shell uname)

# compile with GPROF
# GPROF = 1

# build for build platform
APP_PLATFORM = android-9

ANDR_ROOT = $(shell pwd)
PROJ_ROOT = $(shell realpath $(ANDR_ROOT)/../..)
APP_ROOT = $(ANDR_ROOT)/src/main

GAMES_TO_COPY = minetest_game
MODS_TO_COPY =


VERSION_MAJOR := $(shell cat $(PROJ_ROOT)/CMakeLists.txt | \
	grep ^set\(VERSION_MAJOR\ | sed 's/)/ /' | cut -f2 -d' ')
VERSION_MINOR := $(shell cat $(PROJ_ROOT)/CMakeLists.txt | \
	grep ^set\(VERSION_MINOR\ | sed 's/)/ /' | cut -f2 -d' ')
VERSION_PATCH := $(shell cat $(PROJ_ROOT)/CMakeLists.txt | \
	grep ^set\(VERSION_PATCH\ | sed 's/)/ /' | cut -f2 -d' ')

################################################################################
# toolchain config for arm new processors
################################################################################
TARGET_HOST = arm-linux
TARGET_ABI = armeabi-v7a
TARGET_LIBDIR = armeabi-v7a
TARGET_TOOLCHAIN = arm-linux-androideabi-
TARGET_CFLAGS_ADDON = -mfloat-abi=softfp -mfpu=vfpv3 -O3
TARGET_CXXFLAGS_ADDON = $(TARGET_CFLAGS_ADDON)
TARGET_ARCH = armv7
CROSS_PREFIX = arm-linux-androideabi-
COMPILER_VERSION = 4.9
HAVE_LEVELDB = 1

################################################################################
# toolchain config for little endian mips
################################################################################
#TARGET_HOST = mipsel-linux
#TARGET_ABI = mips
#TARGET_LIBDIR = mips
#TARGET_TOOLCHAIN = mipsel-linux-android-
#TARGET_ARCH = mips32
#CROSS_PREFIX = mipsel-linux-android-
#COMPILER_VERSION = 4.9
#HAVE_LEVELDB = 0

################################################################################
# toolchain config for x86
################################################################################
#TARGET_HOST = x86-linux
#TARGET_ABI = x86
#TARGET_LIBDIR = x86
#TARGET_TOOLCHAIN = x86-
#CROSS_PREFIX = i686-linux-android-
#TARGET_ARCH = x86
#COMPILER_VERSION = 4.9
#HAVE_LEVELDB = 1

################################################################################
ASSETS_TIMESTAMP = deps/assets_timestamp

LEVELDB_DIR = $(ANDR_ROOT)/deps/leveldb/
LEVELDB_LIB = $(LEVELDB_DIR)libleveldb.a
LEVELDB_TIMESTAMP = $(LEVELDB_DIR)/timestamp
LEVELDB_TIMESTAMP_INT = $(ANDR_ROOT)/deps/leveldb_timestamp
LEVELDB_URL_GIT = https://github.com/google/leveldb
LEVELDB_COMMIT = 2d0320a458d0e6a20fff46d5f80b18bfdcce7018

OPENAL_DIR = $(ANDR_ROOT)/deps/openal-soft/
OPENAL_LIB = $(OPENAL_DIR)libs/$(TARGET_ABI)/libopenal.so
OPENAL_TIMESTAMP = $(OPENAL_DIR)/timestamp
OPENAL_TIMESTAMP_INT = $(ANDR_ROOT)/deps/openal_timestamp
OPENAL_URL_GIT = https://github.com/apportable/openal-soft

OGG_DIR = $(ANDR_ROOT)/deps/libvorbis-libogg-android/
OGG_LIB = $(OGG_DIR)libs/$(TARGET_ABI)/libogg.so
VORBIS_LIB = $(OGG_DIR)libs/$(TARGET_ABI)/libogg.so
OGG_TIMESTAMP = $(OGG_DIR)timestamp
OGG_TIMESTAMP_INT = $(ANDR_ROOT)/deps/ogg_timestamp
OGG_URL_GIT = https://github.com/vincentjames501/libvorbis-libogg-android

IRRLICHT_REVISION = 5122
IRRLICHT_DIR = $(ANDR_ROOT)/deps/irrlicht/
IRRLICHT_LIB = $(IRRLICHT_DIR)lib/Android/libIrrlicht.a
IRRLICHT_TIMESTAMP = $(IRRLICHT_DIR)timestamp
IRRLICHT_TIMESTAMP_INT = $(ANDR_ROOT)/deps/irrlicht_timestamp
IRRLICHT_URL_SVN = https://svn.code.sf.net/p/irrlicht/code/branches/ogl-es@$(IRRLICHT_REVISION)

OPENSSL_VERSION = 1.0.2j
OPENSSL_BASEDIR = openssl-$(OPENSSL_VERSION)
OPENSSL_DIR = $(ANDR_ROOT)/deps/$(OPENSSL_BASEDIR)/
OPENSSL_LIB = $(OPENSSL_DIR)/libssl.so.1.0.0
OPENSSL_TIMESTAMP = $(OPENSSL_DIR)timestamp
OPENSSL_TIMESTAMP_INT = $(ANDR_ROOT)/deps/openssl_timestamp
OPENSSL_URL = https://www.openssl.org/source/openssl-$(OPENSSL_VERSION).tar.gz

CURL_VERSION = 7.52.0
CURL_DIR = $(ANDR_ROOT)/deps/curl-$(CURL_VERSION)
CURL_LIB = $(CURL_DIR)/lib/.libs/libcurl.a
CURL_TIMESTAMP = $(CURL_DIR)/timestamp
CURL_TIMESTAMP_INT = $(ANDR_ROOT)/deps/curl_timestamp
CURL_URL_HTTP = https://curl.haxx.se/download/curl-${CURL_VERSION}.tar.bz2

GMP_VERSION = 6.1.2
GMP_DIR = $(ANDR_ROOT)/deps/gmp-$(GMP_VERSION)
GMP_LIB = $(GMP_DIR)/usr/lib/libgmp.so
GMP_TIMESTAMP = $(GMP_DIR)/timestamp
GMP_TIMESTAMP_INT = $(ANDR_ROOT)/deps/gmp_timestamp
GMP_URL_HTTP = https://gmplib.org/download/gmp/gmp-$(GMP_VERSION).tar.bz2

FREETYPE_DIR = $(ANDR_ROOT)/deps/freetype2-android/
FREETYPE_LIB = $(FREETYPE_DIR)/Android/obj/local/$(TARGET_ABI)/libfreetype2-static.a
FREETYPE_TIMESTAMP = $(FREETYPE_DIR)timestamp
FREETYPE_TIMESTAMP_INT = $(ANDR_ROOT)/deps/freetype_timestamp
FREETYPE_URL_GIT = https://github.com/cdave1/freetype2-android

ICONV_VERSION = 1.14
ICONV_DIR = $(ANDR_ROOT)/deps/libiconv/
ICONV_LIB = $(ICONV_DIR)/lib/.libs/libiconv.so
ICONV_TIMESTAMP = $(ICONV_DIR)timestamp
ICONV_TIMESTAMP_INT = $(ANDR_ROOT)/deps/iconv_timestamp
ICONV_URL_HTTP = https://ftp.gnu.org/pub/gnu/libiconv/libiconv-$(ICONV_VERSION).tar.gz

SQLITE3_FOLDER = sqlite-amalgamation-3150200
SQLITE3_URL = https://www.sqlite.org/2016/$(SQLITE3_FOLDER).zip

ANDROID_SDK = $(shell grep '^sdk\.dir' local.properties | sed 's/^.*=[[:space:]]*//')
ANDROID_NDK = $(shell grep '^ndk\.dir' local.properties | sed 's/^.*=[[:space:]]*//')
NDK_MODULE_PATH = $(ANDROID_NDK)/toolchains

#use interim target variable to switch leveldb on or off
ifeq ($(HAVE_LEVELDB),1)
	LEVELDB_TARGET = $(LEVELDB_LIB)
endif

.PHONY : debug release reconfig delconfig \
	leveldb_download clean_leveldb leveldb\
	irrlicht_download clean_irrlicht irrlicht \
	clean_assets assets sqlite3_download \
	freetype_download clean_freetype freetype \
	apk clean_apk \
	clean_all clean prep_srcdir \
	install_debug install_release envpaths all \
	$(ASSETS_TIMESTAMP) $(LEVELDB_TIMESTAMP) \
	$(OPENAL_TIMESTAMP) $(OGG_TIMESTAMP) \
	$(IRRLICHT_TIMESTAMP) $(CURL_TIMESTAMP) \
	$(OPENSSL_TIMESTAMP) \
	$(ANDR_ROOT)/jni/src/android_version.h \
	$(ANDR_ROOT)/jni/src/android_version_githash.h

debug : local.properties
	export NDEBUG=;                                                            \
	export BUILD_TYPE=debug;                                                   \
	$(MAKE) apk

all : debug release

release : local.properties
	@export NDEBUG=1;                                                          \
	export BUILD_TYPE=release;                                                 \
	$(MAKE) apk

reconfig: delconfig
	@$(MAKE) local.properties

delconfig:
	$(RM) local.properties

local.properties:
	@echo "Please specify path of ANDROID NDK";                                \
	echo "e.g. $$HOME/Android/ndk-r11c/";                                  \
	read ANDROID_NDK ;                                                         \
	if [ ! -d $$ANDROID_NDK ] ; then                                           \
		echo "$$ANDROID_NDK is not a valid folder";                            \
		exit 1;                                                                \
	fi;                                                                        \
	echo "ndk.dir = $$ANDROID_NDK" > local.properties;                         \
	echo "Please specify path of ANDROID SDK";                                 \
	echo "e.g. $$HOME/Android/sdk/";                                       \
	read SDKFLDR ;                                                             \
	if [ ! -d $$SDKFLDR ] ; then                                               \
		echo "$$SDKFLDR is not a valid folder";                                \
		exit 1;                                                                \
	fi;                                                                        \
	echo "sdk.dir = $$SDKFLDR" >> local.properties;


$(OPENAL_TIMESTAMP) : openal_download
	@LAST_MODIF=$$(find ${OPENAL_DIR} -type f -printf '%T@ %p\n' | sort -n | tail -1 | cut -f2- -d" "); \
	if [ $$(basename $$LAST_MODIF) != "timestamp" ] ; then                     \
		touch ${OPENAL_TIMESTAMP};                                            \
	fi

openal_download :
	@if [ ! -d ${OPENAL_DIR} ] ; then                                          \
		echo "openal sources missing, downloading...";                         \
		mkdir -p ${ANDR_ROOT}/deps;                                            \
		cd ${ANDR_ROOT}/deps ;                                                 \
		git clone ${OPENAL_URL_GIT} || exit 1;                                 \
	fi

openal : $(OPENAL_LIB)

$(OPENAL_LIB): $(OPENAL_TIMESTAMP)
	+ @REFRESH=0;                                                                \
	if [ ! -e ${OPENAL_TIMESTAMP_INT} ] ; then                                 \
		REFRESH=1;                                                             \
	fi;                                                                        \
	if [ ${OPENAL_TIMESTAMP} -nt ${OPENAL_TIMESTAMP_INT} ] ; then              \
		REFRESH=1;                                                             \
	fi;                                                                        \
	if [ $$REFRESH -ne 0 ] ; then                                              \
	echo "changed timestamp for openal detected building...";                  \
	cd ${OPENAL_DIR};                                                          \
	${ANDROID_NDK}/ndk-build NDEBUG=${NDEBUG}                                  \
		NDK_MODULE_PATH=${NDK_MODULE_PATH} APP_ABI=${TARGET_ABI}               \
		TARGET_ARCH_ABI=${TARGET_ABI} APP_PLATFORM=${APP_PLATFORM}             \
		PRIVATE_CC=${NDK_MODULE_PATH}/${TARGET_TOOLCHAIN}${COMPILER_VERSION}/prebuilt/linux-x86_64/bin/${TARGET_TOOLCHAIN}gcc \
		PRIVATE_CXX=${NDK_MODULE_PATH}/${TARGET_TOOLCHAIN}${COMPILER_VERSION}/prebuilt/linux-x86_64/bin/${TARGET_TOOLCHAIN}g++ \
		TARGET_CFLAGS+="${TARGET_CFLAGS_ADDON}"                                \
		TARGET_LDFLAGS+="${TARGET_LDFLAGS_ADDON}"                              \
		TARGET_CXXFLAGS+="${TARGET_CXXFLAGS_ADDON}" || exit 1;                 \
	touch ${OPENAL_TIMESTAMP};                                                 \
	touch ${OPENAL_TIMESTAMP_INT};                                             \
	else                                                                       \
		echo "nothing to be done for openal";                                  \
	fi

clean_openal :
	$(RM) -rf ${OPENAL_DIR}

$(OGG_TIMESTAMP) : ogg_download
	@LAST_MODIF=$$(find ${OGG_DIR} -type f -printf '%T@ %p\n' | sort -n | tail -1 | cut -f2- -d" "); \
	if [ $$(basename $$LAST_MODIF) != "timestamp" ] ; then                     \
		touch ${OGG_TIMESTAMP};                                                \
	fi

ogg_download :
	@if [ ! -d ${OGG_DIR} ] ; then                                             \
		echo "ogg sources missing, downloading...";                            \
		mkdir -p ${ANDR_ROOT}/deps;                                            \
		cd ${ANDR_ROOT}/deps ;                                                 \
		git clone ${OGG_URL_GIT}|| exit 1;                                     \
		cd libvorbis-libogg-android ;                                          \
		patch -p1 < ${ANDR_ROOT}/patches/libvorbis-libogg-fpu.patch || exit 1; \
		sed -i 's-:-?-' jni/Application.mk;                                    \
	fi

ogg : $(OGG_LIB)

$(OGG_LIB): $(OGG_TIMESTAMP)
	+ @REFRESH=0;                                                                \
	if [ ! -e ${OGG_TIMESTAMP_INT} ] ; then                                    \
		echo "${OGG_TIMESTAMP_INT} doesn't exist";                             \
		REFRESH=1;                                                             \
	fi;                                                                        \
	if [ ${OGG_TIMESTAMP} -nt ${OGG_TIMESTAMP_INT} ] ; then                    \
		REFRESH=1;                                                             \
	fi;                                                                        \
	if [ $$REFRESH -ne 0 ] ; then                                              \
	echo "changed timestamp for ogg detected building...";                     \
	cd ${OGG_DIR};                                                             \
	${ANDROID_NDK}/ndk-build NDEBUG=${NDEBUG}                                  \

=== build/android_fm/Makefile ===
# build options

OS := $(shell uname)

# compile with GPROF
# GPROF = 1

# build for build platform
APP_PLATFORM = android-20

# paths used for timestaps, dependencys, tree config and libs
PATHCFGFILE = path.cfg

ROOT = $(shell pwd)

GAMES_TO_COPY = default
MODS_TO_COPY =


VERSION_MAJOR := $(shell cat $(ROOT)/../../CMakeLists.txt | \
	grep ^set\(VERSION_MAJOR\ | sed 's/)/ /' | cut -f2 -d' ')
VERSION_MINOR := $(shell cat $(ROOT)/../../CMakeLists.txt | \
	grep ^set\(VERSION_MINOR\ | sed 's/)/ /' | cut -f2 -d' ')
VERSION_PATCH := $(shell cat $(ROOT)/../../CMakeLists.txt | \
	grep ^set\(VERSION_PATCH\ | sed 's/)/ /' | cut -f2 -d' ')
VERSION_TWEAK := $(shell cat $(ROOT)/../../CMakeLists.txt | \
	grep ^set\(VERSION_TWEAK\ | sed 's/)/ /' | cut -f2 -d' ')

################################################################################
# Android Version code
# Increase for each build!
################################################################################
# Play Store actual version (16/03/15): 11
ANDROID_VERSION_CODE = 13


#and for freeminer for skip conflict:
#increase by 10
BUILD_NUMBER = 120

ANDROID_VERSION_CODE = $(BUILD_NUMBER)

SDK_VERSION = 24
PROJECT_NAME_C = freeminer

GAMES_VERSION = "5"

GIT_CLONE = git clone --recursive --depth 10

################################################################################
# toolchain config for arm new processors
################################################################################
TARGET_HOST = arm-linux
CROSS_NAME = arm-linux-androideabi
#TARGET_ABI = armeabi-v7a
TARGET_ABI = armeabi-v7a
OPENSSL_TARGET_ARCH = android-armeabi # android android-armeabi android-mips android-x86 android64 android64-aarch64
TARGET_LIBDIR = armeabi-v7a
TARGET_CFLAGS_ADDON = -mfpu=vfpv3-d16 -march=armv7-a -Ofast
#clang: TARGET_CFLAGS_ADDON = -Ofast
TARGET_CXXFLAGS_ADDON = $(TARGET_CFLAGS_ADDON)
TARGET_LDFLAGS_ADDON = -Wl,--no-warn-mismatch,--gc-sections
TARGET_ARCH = armv7
COMPILER_VERSION = 4.9

HAVE_LEVELDB = 1
USE_LUAJIT = 1
USE_ENET = 1
APP_STL = gnustl       # gnustl libcxx|libc++ stlport
#CC = clang
#CXX = clang++
CC = gcc
CXX = g++

#COMPILER_VERSION = clang
#TARGET_CFLAGS_ADDON = -D_NDK_MATH_NO_SOFTFP=1 -Ofast
#STANDALONE_ADDON = --use-llvm --force
STANDALONE_ADDON = --force

ifeq ($(TARGET_arm64),1)
ifneq ($(NO_AUTO_VERSION),1)
ANDROID_VERSION_CODE := $(shell echo $$(( $(ANDROID_VERSION_CODE) + 1 )))
endif
TARGET_HOST = aarch64-linux
TARGET_ABI = arm64-v8a
TARGET_LIBDIR = arm64-v8a
TARGET_TOOLCHAIN = aarch64-linux-android-
TARGET_CFLAGS_ADDON = -Ofast
TARGET_CXXFLAGS_ADDON = $(TARGET_CFLAGS_ADDON)
TARGET_LDFLAGS_ADDON =
CROSS_NAME = aarch64-linux-android
TARGET_ARCH = aarch64
SDK_VERSION = 21

#TODO:
USE_LUAJIT = 0
endif


################################################################################
# toolchain config for little endian mips
################################################################################
ifeq ($(TARGET_mips),1)
ifneq ($(NO_AUTO_VERSION),1)
ANDROID_VERSION_CODE := $(shell echo $$(( $(ANDROID_VERSION_CODE) + 4 )))
endif
TARGET_HOST = mipsel-linux
TARGET_ABI = mips
TARGET_LIBDIR = mips
TARGET_CFLAGS_ADDON = -Ofast
TARGET_CXXFLAGS_ADDON = $(TARGET_CFLAGS_ADDON)
TARGET_LDFLAGS_ADDON =
TARGET_ARCH = mips32
CROSS_NAME = mipsel-linux-android
HAVE_LEVELDB = 0
endif

################################################################################
# toolchain config for x86
################################################################################
ifeq ($(TARGET_x86),1)
ifneq ($(NO_AUTO_VERSION),1)
ANDROID_VERSION_CODE := $(shell echo $$(( $(ANDROID_VERSION_CODE) + 2 )))
endif
TARGET_HOST = x86-linux
TARGET_ABI = x86
TARGET_LIBDIR = x86
TARGET_TOOLCHAIN = x86-
TARGET_CFLAGS_ADDON = -Ofast
TARGET_CXXFLAGS_ADDON = $(TARGET_CFLAGS_ADDON)
TARGET_LDFLAGS_ADDON =
CROSS_NAME = i686-linux-android
TARGET_ARCH = x86
SDK_VERSION = 16
OPENSSL_CONFIGURE_ADDON = no-asm
endif

ifeq ($(TARGET_x86_64),1)
ifneq ($(NO_AUTO_VERSION),1)
ANDROID_VERSION_CODE := $(shell echo $$(( $(ANDROID_VERSION_CODE) + 3 )))
endif
TARGET_HOST = x86_64-linux
TARGET_ABI = x86_64
TARGET_LIBDIR = x86_64
TARGET_TOOLCHAIN = x86_64-
TARGET_CFLAGS_ADDON = -Ofast
TARGET_CXXFLAGS_ADDON = $(TARGET_CFLAGS_ADDON)
TARGET_LDFLAGS_ADDON =
CROSS_NAME = x86_64-linux-android
TARGET_ARCH = x86_64
SDK_VERSION = 21
#OPENSSL_CONFIGURE_ADDON = no-asm

#TODO:
USE_LUAJIT = 0
endif

TARGET_TOOLCHAIN ?= $(CROSS_NAME)-
CROSS_PREFIX ?= $(CROSS_NAME)-

APP_PLATFORM = android-$(SDK_VERSION)

#USE_SCTP = 1


################################################################################
ASSETS_TIMESTAMP = deps/assets_timestamp

LEVELDB_DIR = $(ROOT)/deps/leveldb/
LEVELDB_LIB = $(LEVELDB_DIR)/out-static/libleveldb.a
LEVELDB_TIMESTAMP = $(LEVELDB_DIR)/timestamp
LEVELDB_TIMESTAMP_INT = $(ROOT)/deps/leveldb_timestamp
LEVELDB_URL_GIT = https://github.com/google/leveldb
#LEVELDB_COMMIT = 2d0320a458d0e6a20fff46d5f80b18bfdcce7018

OPENAL_DIR = $(ROOT)/deps/openal-soft/
OPENAL_LIB = $(OPENAL_DIR)libs/$(TARGET_ABI)/libopenal.so
OPENAL_TIMESTAMP = $(OPENAL_DIR)/timestamp
OPENAL_TIMESTAMP_INT = $(ROOT)/deps/openal_timestamp
#OPENAL_URL_GIT = https://github.com/apportable/openal-soft
OPENAL_URL_GIT = https://github.com/zhuowei/openal-soft



OGG_DIR = $(ROOT)/deps/libvorbis-libogg-android/
OGG_LIB = $(OGG_DIR)libs/$(TARGET_ABI)/libogg.so
VORBIS_LIB = $(OGG_DIR)libs/$(TARGET_ABI)/libogg.so
OGG_TIMESTAMP = $(OGG_DIR)timestamp
OGG_TIMESTAMP_INT = $(ROOT)/deps/ogg_timestamp
OGG_URL_GIT = https://github.com/vincentjames501/libvorbis-libogg-android

IRRLICHT_REVISION = 5122
IRRLICHT_DIR = $(ROOT)/deps/irrlicht/
IRRLICHT_LIB = $(IRRLICHT_DIR)lib/Android/libIrrlicht.a
IRRLICHT_TIMESTAMP = $(IRRLICHT_DIR)timestamp
IRRLICHT_TIMESTAMP_INT = $(ROOT)/deps/irrlicht_timestamp
#IRRLICHT_URL_SVN = http://svn.code.sf.net/p/irrlicht/code/branches/ogl-es/
IRRLICHT_URL_GIT = https://github.com/zaki/irrlicht.git
IRRLICHT_GIT_BRANCH = ogl-es
IRRLICHT_GIT_COMMIT = 58fa0cf
#IRRLICHT_GIT_COMMIT = ogl-es

#IRRLICHT_URL_SVN = http://svn.code.sf.net/p/irrlicht/code/branches/ogl-es@$(IRRLICHT_REVISION)

OPENSSL_VERSION = 1.0.2k
#OPENSSL_VERSION = 1.1.0e
OPENSSL_BASEDIR = openssl-$(OPENSSL_VERSION)
OPENSSL_DIR = $(ROOT)/deps/$(OPENSSL_BASEDIR)/
OPENSSL_LIB = $(OPENSSL_DIR)/libssl.so.1.0.0
OPENSSL_TIMESTAMP = $(OPENSSL_DIR)timestamp
OPENSSL_TIMESTAMP_INT = $(ROOT)/deps/openssl_timestamp
OPENSSL_URL = http://www.openssl.org/source/openssl-$(OPENSSL_VERSION).tar.gz

CURL_VERSION = 7.53.1
CURL_DIR = $(ROOT)/deps/curl-$(CURL_VERSION)
CURL_LIB = $(CURL_DIR)/lib/.libs/libcurl.a
CURL_TIMESTAMP = $(CURL_DIR)/timestamp
CURL_TIMESTAMP_INT = $(ROOT)/deps/curl_timestamp
CURL_URL_HTTP = https://curl.haxx.se/download/curl-${CURL_VERSION}.tar.bz2

GMP_VERSION = 6.1.2
GMP_DIR = $(ROOT)/deps/gmp-$(GMP_VERSION)
GMP_LIB = $(GMP_DIR)/usr/lib/libgmp.so
GMP_TIMESTAMP = $(GMP_DIR)/timestamp
GMP_TIMESTAMP_INT = $(ROOT)/deps/gmp_timestamp
GMP_URL_HTTP = https://gmplib.org/download/gmp/gmp-$(GMP_VERSION).tar.bz2

FREETYPE_DIR = $(ROOT)/deps/freetype2-android/
FREETYPE_LIB = $(FREETYPE_DIR)/Android/obj/local/$(TARGET_ABI)/libfreetype2-static.a
FREETYPE_TIMESTAMP = $(FREETYPE_DIR)timestamp
FREETYPE_TIMESTAMP_INT = $(ROOT)/deps/freetype_timestamp
FREETYPE_URL_GIT = https://github.com/cdave1/freetype2-android

ICONV_VERSION = 1.14
ICONV_DIR = $(ROOT)/deps/libiconv/
ICONV_LIB = $(ICONV_DIR)/lib/.libs/libiconv.so
ICONV_TIMESTAMP = $(ICONV_DIR)timestamp
ICONV_TIMESTAMP_INT = $(ROOT)/deps/iconv_timestamp
ICONV_URL_HTTP = http://ftp.gnu.org/pub/gnu/libiconv/libiconv-$(ICONV_VERSION).tar.gz

SQLITE3_FOLDER = sqlite-amalgamation-3180000
SQLITE3_URL = http://www.sqlite.org/2017/$(SQLITE3_FOLDER).zip

-include $(PATHCFGFILE)

#use interim target variable to switch leveldb on or off
ifeq ($(HAVE_LEVELDB),1)
	LEVELDB_TARGET = $(LEVELDB_LIB)
endif

.PHONY : debug release reconfig delconfig \
	leveldb_download clean_leveldb leveldb\
	irrlicht_download clean_irrlicht irrlicht \
	clean_assets assets sqlite3_download \
	freetype_download clean_freetype freetype \
	apk clean_apk \
	clean_all clean prep_srcdir \
	install_debug install envpaths all \
	manifest clean_manifest\
	$(ASSETS_TIMESTAMP) $(LEVELDB_TIMESTAMP) \
	$(OPENAL_TIMESTAMP) $(OGG_TIMESTAMP) \
	$(IRRLICHT_TIMESTAMP) $(CURL_TIMESTAMP) \
	$(OPENSSL_TIMESTAMP) \
	$(ROOT)/jni/src/android_version.h \
	$(ROOT)/jni/src/android_version_githash.h

default: release

debug : $(PATHCFGFILE)
	export NDEBUG=;                                                            \
	export BUILD_TYPE=debug;                                                   \
	$(MAKE) apk

all : debug release

release : $(PATHCFGFILE)
	@export NDEBUG=1;                                                          \
	export BUILD_TYPE=release;                                                 \
	$(MAKE) apk

reconfig: delconfig
	@$(MAKE) $(PATHCFGFILE)

delconfig :
	$(RM) ${PATHCFGFILE}

$(PATHCFGFILE) :
	@echo "Please specify path of ANDROID NDK";                                \
	echo "e.g. /home/user/android-ndk-r9c/";                                   \
	read ANDROID_NDK ;                                                         \
	if [ ! -d $$ANDROID_NDK ] ; then                                           \
		echo "$$ANDROID_NDK is not a valid folder";                            \
		exit 1;                                                                \
	fi;                                                                        \
	echo "ANDROID_NDK = $$ANDROID_NDK" > ${PATHCFGFILE};                       \
	echo "NDK_MODULE_PATH = $$ANDROID_NDK/toolchains" >> ${PATHCFGFILE};            \
	echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++";\
	echo "+ Note: NDK_MODULE_PATH is set to $$ANDROID_NDK/toolchains";              \
	echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++";\
	echo "Please specify path of ANDROID SDK";                                 \
	echo "e.g. /home/user/adt-bundle-linux-x86_64-20131030/sdk/";              \
	read SDKFLDR ;                                                             \
	if [ ! -d $$SDKFLDR ] ; then                                               \
		echo "$$SDKFLDR is not a valid folder";                                \
		exit 1;                                                                \
	fi;                                                                        \
	echo "SDKFOLDER = $$SDKFLDR" >> ${PATHCFGFILE};

$(OPENAL_TIMESTAMP) : openal_download
	@LAST_MODIF=$$(find ${OPENAL_DIR} -type f -printf '%T@ %p\n' | sort -n | tail -1 | cut -f2- -d" "); \
	if [ $$(basename $$LAST_MODIF) != "timestamp" ] ; then                     \
		touch ${OPENAL_TIMESTAMP};                                            \
	fi

openal_download :
	@if [ ! -d ${OPENAL_DIR} ] ; then                                          \
		echo "openal sources missing, downloading...";                         \
		mkdir -p ${ROOT}/deps;                                                 \
		cd ${ROOT}/deps ;                                                      \
		${GIT_CLONE} ${OPENAL_URL_GIT} || exit 1;                                 \
	fi

openal : $(OPENAL_LIB)

$(OPENAL_LIB): $(OPENAL_TIMESTAMP)
	+ @REFRESH=0;                                                                \
	if [ ! -e ${OPENAL_TIMESTAMP_INT} ] ; then                                 \
		REFRESH=1;                                                             \
	fi;                                                                        \
	if [ ${OPENAL_TIMESTAMP} -nt ${OPENAL_TIMESTAMP_INT} ] ; then              \
		REFRESH=1;                                                             \
	fi;                                                                        \
	if [ $$REFRESH -ne 0 ] ; then                                              \
	export PATH=$$PATH:${SDKFOLDER}/platform-tools:${ANDROID_NDK};             \
	echo "changed timestamp for openal detected building...";                  \

=== src/contrib/CMakeLists.txt ===
set(contrib_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/environment.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/fallingsao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/itemsao.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/l_env.cpp
	PARENT_SCOPE
)

=== src/network/CMakeLists.txt ===
set(common_network_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/connection.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/networkpacket.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/serverpackethandler.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/serveropcodes.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/fm_lan.cpp
	PARENT_SCOPE
)

if (BUILD_CLIENT)
	set(client_network_SRCS
		${CMAKE_CURRENT_SOURCE_DIR}/clientopcodes.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/clientpackethandler.cpp
		PARENT_SCOPE
	)
endif()

=== build/debian/changelog ===
freeminer (0.4.8.2) unstable; urgency=low
  * freeminer 0.4.8.2
 -- proler <proler@gmail.com>  Fri, 06 Dec 2013 22:00:00 +0100

freeminer (0.4.8.1) unstable; urgency=low
  * freeminer 0.4.8.1
 -- proler <proler@gmail.com>  Fri, 06 Dec 2013 14:40:00 +0100

freeminer (0.4.8.0) unstable; urgency=low
  * freeminer initial
 -- p <p@p>  Thu, 28 Nov 2013 23:20:35 +0100

minetest (0.4.8+repack2-1) unstable; urgency=low

  * New upstream release (closes: #730554).
    - Upstream changes to their embeeded jthread library become
      intractable with our system-wide version. So switch to their
      version, even if it's a bad habit to embeed other libraries.
    - Refresh our patches (no big change beside of jthread).
  * Suggests the existing mod packages: moreblocks, moreores, pipeworks.

 -- Martin Quinson <mquinson@debian.org>  Thu, 28 Nov 2013 23:20:35 +0100

minetest (0.4.7+repack-3) unstable; urgency=low

  * d/p/desktop-file-fix-icon: fix the icon name in minetest.desktop
    (Closes: #713808)

 -- Martin Quinson <mquinson@debian.org>  Sun, 18 Aug 2013 02:34:11 +0200

minetest (0.4.7+repack-2) unstable; urgency=low

  * Fix the package description (the game is LGPL, not GPL)

 -- Martin Quinson <mquinson@debian.org>  Fri, 21 Jun 2013 01:54:04 +0200

minetest (0.4.7+repack-1) unstable; urgency=low

  * New upstream release (LP: #1191519)
    - all mods but 'minetest_game' mods were dropped upstream. 
      We still need to repack to integrate the remaining mod, though.
  * Refresh our patches accordingly
  * Build-depend on luajit as it is now the used library for lua
  * d/control: bump standard version to 3.9.4 (no change needed)

 -- Martin Quinson <mquinson@debian.org>  Fri, 21 Jun 2013 01:13:36 +0200

minetest (0.4.6+repack-6) unstable; urgency=low

  * Reupload to unstable so that it gets rebuilt against irrlicht 1.8. 
    We could have asked a binNMU to the release team for the transition, 
    but minetest is the only package build-depending on irrlicht.

 -- Martin Quinson <mquinson@debian.org>  Mon, 06 May 2013 11:36:12 +0200

minetest (0.4.6+repack-5) unstable; urgency=low

  * include minetest-mapper into the minetest-data package
  * don't install in-package fonts, but use system-wide ones
  * Actually install the upstream changelog -- oops

 -- Martin Quinson <mquinson@debian.org>  Wed, 01 May 2013 18:59:48 +0200

minetest (0.4.6+repack-4) unstable; urgency=low

  * Team upload.

  [Matthew Bekkema]
  * Fix build on big endian architectures.
  
  [Martin Quinson]
  * minetest Suggests minetest-server (Closes: #674121)
  * Conflicts with unofficial minetestc55 (LP: #1162551)

 -- Martin Quinson <mquinson@debian.org>  Fri, 19 Apr 2013 10:06:45 +0200

minetest (0.4.6+repack-3) unstable; urgency=low

  * Team upload.

  [Matthew Bekkema]
  * Fix build on kfreebsd, and hopefully on sparc
  * Further source repacking to remove unused embeedded libraries from
    tarball.
    
  [Martin Quinson]
  * d/control: update upstream's URL

 -- Martin Quinson <mquinson@debian.org>  Thu, 18 Apr 2013 09:41:54 +0200

minetest (0.4.6+repack-2) unstable; urgency=low

  * Add an upstream changelog found online
  * Ease the upgrade from previous minetest versions -- sorry.

 -- Martin Quinson <mquinson@debian.org>  Wed, 17 Apr 2013 22:09:29 +0200

minetest (0.4.6+repack-1) unstable; urgency=low

  * Team upload.
  * New upstream release (Closes: #677517) (LP: #1045322)
    - Player cannot spawn within the rock now (Closes: #693264)
    - Builds with irrlicht 1.8 (Closes: #693277)
  * Repack upstream tarball to re-include the elements that were
    separated "to keep the git repository reasonably sized"

  [Matthew Bekkema]
  * Update existing patches.
  * Use upstream manpages and drop Debian ones.
  * d/rules: various fixes:
    - update the way to get new tarballs
    - copy the icons from the right location
  * d/p/event.patch: new patch to make it compile despite upstream
    editing their included jmutex.h while we use the system-wide one.
  * Be more picky about what should get installed in minetest-common
    to avoid conflicts with minetest.
  * d/copyright: various fixes
    - fix a lintian warning about a duplicated entry
    - upstream switched to LGPL v2 for most files
    - add some missing files
  * d/p/useless-depends.patch: drop useless dependencies reported
    during build by dpkg-shlibdeps
  * d/control: adapt build-deps to drop these dependencies
  
  [Martin Quinson]
  * d/control: Add myself to the uploaders.
  * d/control: rename the minetest-common pkg to minetest-data, as an
    external source package should/will provide minetest.
  * build with cURL, gettext and freetype
  * d/p/i18n: search for translations in the default path
  * Use system-wide fonts, to avoid a warning about not found fonts
  * Use /usr/share/games/minetest instead of /usr/share/minetest
  * Use upstream desktop file and drop Debian one.

 -- Martin Quinson <mquinson@debian.org>  Sun, 14 Apr 2013 20:58:27 +0200

minetest (0.3.1+dfsg-4) unstable; urgency=low

  * add a breaks minetest << 0.3.1+dfsg-3 to appropriately handle upgrades
    after the package split (closes: #670208)

 -- Michael Gilbert <mgilbert@debian.org>  Wed, 25 Apr 2012 16:04:01 -0400

minetest (0.3.1+dfsg-3) unstable; urgency=low

  * use debhelper 9 and simplify build hardening
  * update my email address
  * bump standards to 3.9.3
  * build-depend on libpng-dev instead of libpng12-dev (closes: #662432)
  * fix gcc 4.7 build failure (closes: #667280)
  * split the server into its own package (closes: #668004)
  * move binaries to /usr/games in install files

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 21 Apr 2012 15:52:14 -0400

minetest (0.3.1+dfsg-2) unstable; urgency=low

  * Fix freedesktop menu "Type" entry.
  * Use "uscan --force-download" in get-orig-source rule.
  * Update homepage location in watch file.
  * Add missing libsqlite3-dev build-dep



=== build/debian/control ===
Source: freeminer
Section: games
Priority: extra
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Michael Gilbert <mgilbert@debian.org>,
 Martin Quinson <mquinson@debian.org>	 
Build-Depends:
 debhelper (>= 9),
 cmake,
 gettext,
 imagemagick,
 libcurl4-gnutls-dev,
 libfreetype6-dev,
 libirrlicht-dev (>= 1.7.0),
 libluajit-5.1-dev,
 zlib1g-dev,
 libsqlite3-dev,
 libogg-dev,
 libvorbis-dev,
 libopenal-dev,
 libjsoncpp-dev,
Standards-Version: 3.9.4
Homepage: http://freeminer.org/
Vcs-Git: git://git.debian.org/git/pkg-games/freeminer-v04x.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/freeminer-v04x.git

Package: freeminer
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 freeminer-data (= ${source:Version}),
Suggests:
 freeminer-server,
 freeminer-mod-moreblocks,
 freeminer-mod-moreores,
 freeminer-mod-pipeworks,
Description: Multiplayer infinite-world block sandbox
 freeminer is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.

Package: freeminer-dbg
Architecture: any
Section: debug
Depends:
 ${misc:Depends},
 freeminer (= ${binary:Version}),
 freeminer-server (= ${binary:Version}),
Description: Multiplayer infinite-world block sandbox (debugging symbols)
 Freeminer is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the debugging symbols in case something goes wrong.

Package: freeminer-server
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 freeminer-data (= ${source:Version}),
Description: Multiplayer infinite-world block sandbox (server)
 Freeminer is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 This is the freeminer server package.

Package: freeminer-data
Architecture: all
Depends:
 ${misc:Depends},
 fonts-liberation,
 python, python-imaging,
Description: Multiplayer infinite-world block sandbox (data files)
 Freeminer is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the files used by both client and server packages, such as
 the textures and other graphical files and the standard mods.
